//+-------------------------------------------------------------------+
//|                                                        watson.mq4 |
//|                                                               yyy |
//|  ", !"                            |
//| GBPUSD,  1 ,   1,000                    |
//| :                                                          |
//|  -          70.    |
//|         230                             |
//|  -          30.|
//|         270                             |
//|       200.     |
//|  :  450                                  |
//|  :     700                                  |
//+-------------------------------------------------------------------+
#property copyright "yyy"
#property link      ""
#define MAGIC_NUM 111111

//--- input parameters
extern int       nedohod_podd=70;    //    ;
extern int       zabros_podd=230;    //    ;
extern int       nedohod_sopr=30;    //    ;
extern int       zabros_sopr=270;    //    ;
extern int       sl=450;             // stop-loss;
extern int       tp=700;             // take-profit;
extern int       risk_percent=10;    //  ,  ;
extern int       otboy=200;          //        ;

       string    symb;               //    ;
       int       timeframe;          //   ;
       datetime  new_time;           //   ;
       int       ticket_global;      //        deinit();

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

int init()
  {
   symb=Symbol();
   timeframe=Period();
   new_time=Time[0];
   
   if(nedohod_podd>=500 || zabros_podd>=500 || nedohod_sopr>=500 || zabros_sopr>=500) //      ;
     {
      Alert("     ( >= 500).  .");
      while(true)
         Sleep(5000);
     }

   if(nedohod_podd+otboy+tp+nedohod_sopr>1000)                          //         ;
      Alert("nedohod_podd + otboy + tp + nedohod_sopr > 1000 --       ");


   int stoplevel=MarketInfo(symb,MODE_STOPLEVEL);
   if(sl<stoplevel)                                                                   //     stop-loss;
     {
      Alert(" stop-loss    (",stoplevel,").  .");
      while(true)
         Sleep(5000);
     }
   if(tp<stoplevel)                                                                   //     take-profit;
     {
      Alert(" take-profit    (",stoplevel,").  .");
      while(true)
         Sleep(5000);
     }

   int freezelevel=MarketInfo(symb,MODE_FREEZELEVEL);
   if(otboy<=freezelevel)              //       (      );
      Alert("otboy    (", freezelevel,").    .");


   if(MarketInfo(symb,MODE_MINLOT) * MarketInfo(symb,MODE_MARGINREQUIRED) > AccountFreeMargin() )               //    ;
     {
      Alert("   .  .");
      while(true)
         Sleep(5000);
     }

   if(symb!="GBPUSD" || timeframe!=PERIOD_H1)                                                 //  ,    ;
     {
      Alert("     (   GBPUSD).  .");
      while(true)
         Sleep(5000);
     }

   return(0);
  }
   
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

int start()
  {
   //------------------------------------------------------------------
   //---   1.     --------------------------------
   //------------------------------------------------------------------
   static int ticks;                                     //     ;
              ticks++;                                   //   ;
   
   // 2.
   bool   new_bar;                                       //   ;
          new_bar=false;
   
   // 3.
   int    total;                                         //      ;
   int    ticket_old;                                    //  ()   ;
   int    type_old;                                      //     (0-buy, 1-sell, 4-buystop, 5-sellstop);
   double openprice_old;                                 //     ;
   double lot_old;                                       //    ;
   
   // 4.
   double average4;                                      //     4- .;
          average4=NormalizeDouble((Close[1]+Close[2]+Close[3]+Close[4])/4,Digits);
   double uroven;                                        //     1,000;
          uroven=NormalizeDouble(Bid,2);
   int    signal;                                        //   (1x)/(2)/(3)  ;
   static double bid_old;                                //  Bid   ;
                 if(ticks==1) bid_old=Bid;
   int    freezelevel;                                   //      ;
          freezelevel=MarketInfo(symb,MODE_FREEZELEVEL);
   static double uroven_old;                             //     ;
                 if(ticks==1) uroven_old=uroven;                      

   // 5.
   bool   modify;                                        //     ;
          modify=false;
   bool   delete;                                        //     ;
          delete=false;
   
   // 6.
   double money_free;                                    //    ;
   double money_lot;                                     //  1-  (  );
   double money_point;                                   //  1-     (  );
   double lot_min;                                       //    ( );
   double lot_step;                                      //    ;
   double lot_new;                                       //     ;
   double risk_percent_new;                              //  ,   -  . ;
   
   // 7.
   int    ticket_new;                                    //  ()   -   ;
   
   


   //------------------------------------------------------------------
   //---   2.     -----------------------------
   //------------------------------------------------------------------
   if(new_time!=Time[0])         //     ,
     {
      new_bar=true;              //  ,    ;
      new_time=Time[0];          //   New_Time;
     }
      
      
   //------------------------------------------------------------------
   //---   3.     ------------------------------------------
   //------------------------------------------------------------------
   for(int i=1; i<=OrdersTotal(); i++)          //   ;
     {
      if(OrderSelect(i-1,SELECT_BY_POS)==true)  //    ;
        {                                       
         if(OrderMagicNumber()!=MAGIC_NUM)      //       ;
            continue;                           //    ;
         total++;                               //    ;
         if (total>1)                           //       ;
           {
            Alert("   .  .");
            while(true)                         //  start() ;
               Sleep(5000);
           }
         ticket_old    =OrderTicket();          //   ;
         type_old      =OrderType();            //   ;
         openprice_old =OrderOpenPrice();       //    ;
         lot_old       =OrderLots();            //   ;
        }
     }
   if(type_old>1)                               //    
      ticket_global=ticket_old;                 //         deinit();
   ticket_global=0;                             //    ,    ;


   //------------------------------------------------------------------
   //---   4.      ------------------------
   //------------------------------------------------------------------
   
   //---     
   if(total==0 
         && Close[1]<average4 
            && Close[1]<Close[2] 
               && Bid<=uroven+nedohod_podd*Point 
                  && Bid>uroven-zabros_podd*Point)           //   ,  . 
      signal=11;                                             //         ;
   
   if(total==0 
         && Close[1]>average4 
            && Close[1]>Close[2] 
               && Bid>=uroven-nedohod_sopr*Point  
                  && Bid<uroven+zabros_sopr*Point)           //   ,  .  
      signal=12;                                             //         ;

   //---     
   if(type_old==4 
         && Ask<openprice_old 
            && Bid<bid_old 
               && Bid<uroven+nedohod_podd*Point 
                  && Bid>=uroven-zabros_podd*Point 
                     && MathAbs(Ask-openprice_old)/Point>freezelevel)    //   .    Ask     ... 
      signal=21;                                              // ... ,      .  .freezelevel;
   
   if(type_old==5 
         && Bid>openprice_old 
            && Bid>bid_old 
               && Bid>uroven-nedohod_sopr*Point
                  && Bid<=uroven+zabros_sopr*Point 
                     && MathAbs(Bid-openprice_old)/Point>freezelevel)    //   .    Bid     ... 
      signal=22;                                              // ... ,      .  .freezelevel;
     
     
   //---     
   if( type_old==4 
         && (Bid<uroven-zabros_podd*Point || uroven!=uroven_old) 
            && MathAbs(Ask-openprice_old)/Point>freezelevel )        //        Bid   ...
      signal=31;                                                     // ...      ,  freezelevel .;
   
   if( type_old==5 
         && (Bid>uroven+zabros_sopr*Point || uroven!=uroven_old) 
            && MathAbs(Bid-openprice_old)/Point>freezelevel )        //        Bid   ...
      signal=32;                                                     // ...  -    ,  freezelevel .;

   bid_old=Bid;                                                   //   bid_old   ;
   uroven_old=uroven;                                             //         ;




   //------------------------------------------------------------------
   //---   5.        ---------------
   //------------------------------------------------------------------
   switch(signal)                      //    (21; 22; 31; 32),    ;
     {
      case 21: modify=OrderModify(ticket_old,Bid+0.00200,Bid-0.00250,Bid+0.00900,0);
               // modify=OrderModify(ticket_old,Ask+otboy*Point,Bid+(otboy-sl)*Point,Bid+(otboy+tp)*Point,0);
               if(modify==true)
                 {
                  Alert("   BuyStop ",ticket_old);
                  return(0);
                 }
               Alert("   BuyStop -  ",GetLastError());
               return(0);
      case 22: modify=OrderModify(ticket_old,Bid-0.00200,Bid+0.00250,Bid-0.00900,0);
               // modify=OrderModify(ticket_old,Bid-otboy*Point,Ask-(otboy-sl)*Point,Ask-(otboy+tp)*Point,0);
               if(modify==true)
                 {
                  Alert ("   SellStop ",ticket_old);
                  return(0);
                 }
               Alert("   SellStop -  ",GetLastError());
               return(0);
      case 31: delete=OrderDelete(ticket_old);
               if(delete==true)
                 {
                  Alert("   BuyStop ",ticket_old);
                  return(0);
                 }
               Alert("   BuyStop -  ",GetLastError());
               return(0);
      case 32: delete=OrderDelete(ticket_old);
               if(delete==true)
                 {
                  Alert("   SellStop ",ticket_old);
                  return(0);
                 }
               Alert("   SellStop -  ",GetLastError());
               return(0);
     }



   //------------------------------------------------------------------
   //---   6.         ------------
   //------------------------------------------------------------------
   money_free =AccountFreeMargin();                  //    ;
   money_lot  =MarketInfo(symb,MODE_MARGINREQUIRED); //  1-  (  );
   money_point=money_lot*Point;                      //  1-     (  );
   lot_min    =MarketInfo(symb,MODE_MINLOT);         //    ( );
   lot_step   =MarketInfo(symb,MODE_LOTSTEP);        //    ;

   lot_new=MathFloor(money_free*(risk_percent/100)/(sl*money_point)/lot_step)*lot_step; //     ;
//   lot_new=MathFloor(money_free*(risk_percent/100)/money_lot/lot_step)*lot_step; //     ;

   Comment("");                                      //  ,      -  ;
   if(lot_new < lot_min)                             //       ;
     {
      lot_new=lot_min;
      risk_percent_new = lot_new*money_lot/money_free*100; //  ,   -  . ;
      Comment("    ", risk_percent_new, "% !!!!!");
     }
   if(lot_new * money_lot > money_free && total==0)  //    ,       ;
     {
      Alert("       ", lot_new, " ().  .");
      while(true)                                    //  start() ;
         Sleep(5000);
     }



   //------------------------------------------------------------------
   //---   7.      ---------------------------
   //------------------------------------------------------------------
   if(total>0 || new_bar==false)       //           ;
      return(0);                       //    start();

   switch(signal)                      //       (11; 12)   ;
     {
      case 11: ticket_new=OrderSend(symb,OP_BUYSTOP,lot_new,Bid+0.00200,30,Bid-0.00250,Bid+0.00900,NULL,MAGIC_NUM); 
               // ticket_new=OrderSend(symb,OP_BUYSTOP,lot_new,Ask+otboy*Point,30,Bid+(otboy-sl)*Point,Bid+(otboy+tp)*Point,NULL,MAGIC_NUM);
               if(ticket_new>0)
                 {
                  Alert("   BuyStop ",ticket_new);
                  if(risk_percent_new > risk_percent)
                     Alert("  ",risk_percent_new,"  ");
                  return(0);
                 }
               Alert("   BuyStop -  ",GetLastError());
               return(0);
      case 12: ticket_new=OrderSend(symb,OP_SELLSTOP,lot_new,Bid-0.00200,30,Bid+0.00250,Bid-0.00900,NULL,MAGIC_NUM);
               // ticket_new=OrderSend(symb,OP_SELLSTOP,lot_new,Bid-otboy*Point,30,Ask-(otboy-sl)*Point,Ask-(otboy+tp)*Point,NULL,MAGIC_NUM); 
               if(ticket_new>0)
                 {
                  Alert("   SellStop ",ticket_new);
                  if(risk_percent_new > risk_percent)
                     Alert("  ",risk_percent_new,"  ");
                  return(0);
                 }
               Alert("   SellStop -  ",GetLastError());
               return(0);
     }

//----
   return(0);
  }


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

int deinit()
  {
   if(ticket_global>0)
     {
      bool del=OrderDelete(ticket_global);
      if(del==true)
        {
         Alert("   ",ticket_global);
         return(0);
        }
      Alert("     ",ticket_global, " -  ",GetLastError());
      return(0);
     }
   return(0);
  }
  
//+------------------------------------------------------------------+

